package com.uracle.cloudpush;

import android.app.Notification;
import android.content.Context;
import android.content.Intent;
import android.media.RingtoneManager;
import android.net.Uri;
import android.util.Log;

import org.json.JSONObject;

import java.util.ArrayList;
import java.util.Arrays;

import m.client.push.library.notification.NotificationBuilder;

public class FcmCustomNoti {
    private static FcmCustomNoti mPushInstance;

    public static FcmCustomNoti getInstance() {
        if (mPushInstance == null) {
            mPushInstance = new FcmCustomNoti();
        }

        return mPushInstance;
    }

    public NotificationBuilder showNotification(Intent intent, Context context) throws Exception {
        String jsonData = intent.getExtras().getString("JSON");
        String psid = intent.getExtras().getString("PSID");
        String encryptData = intent.getExtras().getString("message_encrypt");
        JSONObject jsonObject = new JSONObject(jsonData);
//        JSONObject apsJsonObj = jsonObject.getJSONObject("aps");
//        JSONObject mpsJsonObj = jsonObject.getJSONObject("mps");
        Log.e("FcmCustomNoti_::",""+jsonData);
        String extData = "";
        /*if (mpsJsonObj.has("ext")) {
            extData = mpsJsonObj.optString("ext");
            System.out.println("extData: " + extData);
        }*/
        return createCustomNotification(context,jsonObject,psid,extData);
    }

    private NotificationBuilder createCustomNotification(final Context context, final JSONObject jsonMsg, final String psid, String message) {
        ArrayList<String> params = null;
        if (message != null) {
            String[] paramArray = message.split("\\|");
            params = new ArrayList<String>(Arrays.asList(paramArray));
        }

        int icon = context.getResources().getIdentifier("ic_launcher", "mipmap", context.getPackageName());
        Uri soundUri = RingtoneManager.getDefaultUri(RingtoneManager.TYPE_NOTIFICATION);

//        Bitmap largeIcon = BitmapFactory.decodeResource(context.getResources(), R.drawable.start_bg);
//        NotificationCompat.BigPictureStyle style = new NotificationCompat.BigPictureStyle();
//        style.setBigContentTitle("title");
//        style.setSummaryText(message);
//        style.bigPicture(largeIcon);

        //String NOTIFICATION_CHANNEL_ID = context.getPackageName();


        NotificationBuilder builder = new NotificationBuilder();
        //더 자세한 custom 내용은 wiki를 참고하시기 바랍니다.
        //
        //pendingIntent(LAUNCHER, startpage 외에 별도 페이지로 이동 시) 작성 참고
//        boolean isRunningApp = PushUtils.isRunningPushApps(context);
//        Intent intent = new Intent(context, SampleActivity.class);
//        intent.putExtra("PUSH_TYPE", "FCM");
//        intent.putExtra("PUSH_STATUS", (isRunningApp) ? PushConstants.APP_STATUS_ACTIVE : PushConstants.APP_STATUS_BACKGROUND);
//        intent.addFlags(Intent.FLAG_ACTIVITY_NEW_TASK | Intent.FLAG_ACTIVITY_CLEAR_TOP | Intent.FLAG_ACTIVITY_SINGLE_TOP);
//        intent.putExtra("JSON", jsonMsg.toString());
//        intent.putExtra("PS_ID", psid);
//        intent.putExtra("TITLE", "alertMessage");
//        intent.putExtra("ENCRYPT", "encryptData");
//        intent.putExtra("EXT", "ext");
//        PendingIntent pIntent = PendingIntent.getActivity(context, 0, intent, PendingIntent.FLAG_UPDATE_CURRENT | PendingIntent.FLAG_IMMUTABLE);
//        //---------------------------

        //builder.setStyle(style);
        builder.setAutoCancel(true);
        builder.setContentTitle("alertMessage");
        builder.setContentText("contetnt_text");
        builder.setSmallIcon(icon);
        //builder.setLargeIcon(largeIcon);
        builder.setSound(soundUri);
        //builder.setContentIntent(pIntent);
        builder.setPriority(Notification.PRIORITY_HIGH);
        builder.setDefaults(Notification.DEFAULT_VIBRATE);

        //NotificationChannel도 별도로 custom 하는 경우
        /*if (android.os.Build.VERSION.SDK_INT >= android.os.Build.VERSION_CODES.O) {
            NotificationChannel channel = new NotificationChannel("NOTIFICATION_CHANNEL_ID", "CHANNEL_NAME", NotificationManager.IMPORTANCE_HIGH);
            채널 설정...
            builder.setChannel(channel);//NotificationChannel 세팅
            builder.setChannelId(NOTIFICATION_CHANNEL_ID); 채널 ID
        }*/

        return builder;
    }

}