package com.uracle.cloudpush;

import android.app.Activity;
import android.app.AlertDialog;
import android.app.NotificationManager;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.os.Bundle;
import android.os.Handler;
import android.text.TextUtils;
import android.util.Log;

import com.uracle.cloudpush.common.CommonDef;
import com.uracle.cloudpush.common.Utils;

import org.json.JSONException;
import org.json.JSONObject;

import java.util.HashMap;
import java.util.Iterator;
//import com.uracle.push.demo.R;
import m.client.push.library.PushManager;
import m.client.push.library.common.PushConstants;
import m.client.push.library.utils.PushUtils;

public class IntroActivity extends Activity {

	private static final String TAG  = "IntroActivity";

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.moe_intro);
		//PushManager.getInstance().setCustomInstance(this, FcmCustomNoti11.class);//"com.uracle.cloudpush.FcmCustomNoti"

		//notification data clear 
		NotificationManager mManager = (NotificationManager)getSystemService(Context.NOTIFICATION_SERVICE);
		mManager.cancelAll();

		goLoginProcess();

	}

	@Override
	protected void onResume() {
		// TODO Auto-generated method stub
		super.onResume();
		
	}

	@Override
	protected void onPause() {
		super.onPause();
		//onPause 또는 onNewIntent를 Override하여 해당 영역에 아래 내용 적용
		Intent it = getIntent();
		String notification = it.getStringExtra("JSON");
		JSONObject payload = new JSONObject();
		if (notification!=null) {
			try {
				payload.put("status", "SUCCESS");
				payload.put("payload", notification);
				//데이터 전달 관련 비즈니스 로직 구현
				Log.e("onPause", notification);
			} catch (JSONException e) {

			}
		}
	}

	public void goLoginProcess(){
		if (Utils.getConfigString(IntroActivity.this, CommonDef.CONFIG_SAVE_LOGIN).equalsIgnoreCase("Y")){
			//goPushMessageBox();


			final String cuid = PushUtils.getStringFromStorage(CommonDef.CONFIG_USER_CUID, getApplicationContext());
			final String cname = PushUtils.getStringFromStorage(CommonDef.CONFIG_USER_NAME, getApplicationContext());


			if(TextUtils.isEmpty(cuid) || TextUtils.isEmpty(cname)){
				goLoginPage();
			}


			new Handler().postDelayed(new Runnable() {

				@Override
				public void run() {
					// TODO Auto-generated method stub
					//	Utils.showProgressBar(IntroActivity.this, "로그인 중입니다.", "______");

					JSONObject params = new JSONObject();
					try {

						String url = PushUtils.getStringFromStorage(PushConstants.KEY_RECEIVER_SERVER_URL, getApplicationContext(), "");
						params.put(PushConstants.KEY_CUSTOM_RECEIVER_SERVER_URL, url);
						params.put(PushConstants.KEY_CUID, cuid);
						params.put(PushConstants.KEY_CNAME, cname);
					} 
					catch (JSONException e) {
						e.printStackTrace();
					}

					PushManager.getInstance().registerServiceAndUser(getApplicationContext(), params);
					startActivity(new Intent(IntroActivity.this, PushListActivity.class));
					finish();

				}
			}, 1000);


		}else{
			goLoginPage();
		}
	}


	private void goLoginPage(){
		new Handler().postDelayed(new Runnable(){
			public void run(){
				Intent pageIntent = new Intent(IntroActivity.this, LoginActivity.class);
				startActivity(pageIntent);
				finish();
			}
		},1000);

	}

	/*@Override
	이 부분을 별도의 Activity를 만들어서 거기에 구분해서 넣어라.
	protected void onNewIntent(Intent intent) {
		super.onNewIntent(intent);
		JSONObject payload = new JSONObject();
		String notification = intent.getStringExtra("JSON");
		if (notification!=null) {
			try {
				payload.put("status", "SUCCESS");
				payload.put("payload", notification);
				//데이터 전달 관련 비즈니스 로직 구현
				Log.e("onNewIntent", notification);
			} catch (JSONException e) {

			}
		}
	}*/

}
