package com.uracle.cloudpush.notification;

import android.app.Notification;
import android.app.NotificationChannel;
import android.app.NotificationManager;
import android.app.PendingIntent;
import android.content.ComponentName;
import android.content.Context;
import android.content.Intent;
import android.content.pm.ApplicationInfo;
import android.content.pm.PackageInfo;
import android.content.pm.PackageManager;
import android.graphics.Bitmap;
import android.graphics.Color;
import android.media.RingtoneManager;
import android.net.Uri;
import android.os.Build;
import android.os.Handler;
import android.os.Message;
import android.text.TextUtils;
import android.util.Log;
import android.view.View;

import androidx.core.app.NotificationCompat;

import com.nostra13.universalimageloader.core.ImageLoader;
import com.nostra13.universalimageloader.core.ImageLoaderConfiguration;
import com.nostra13.universalimageloader.core.assist.FailReason;
import com.nostra13.universalimageloader.core.listener.SimpleImageLoadingListener;
import com.uracle.cloudpush.IntroActivity;
import com.uracle.cloudpush.LoginActivity;
import com.uracle.cloudpush.PushListActivity;
import com.uracle.cloudpush.common.CommonDef;
import com.uracle.cloudpush.common.Utils;
import com.uracle.cloudpush.db.DBUtils;
import com.uracle.cloudpush.helper.ContentType;
import com.uracle.cloudpush.helper.Define;

import org.json.JSONException;
import org.json.JSONObject;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Objects;

import m.client.push.library.PushManager;
import m.client.push.library.common.PushConstants;
import m.client.push.library.notification.GetStringHttpThread;
import m.client.push.library.notification.NotificationBuilder;
import m.client.push.library.utils.PushUtils;

public class UpnsNotifyHelper2 {
	public static NotificationBuilder notification = null;
	public static int icon = 0;
	/**
	 * showNotification
	 * 메세지를 분석하여 타입 별 노티피케이션 생성
	 * @param context
	 * @param jsonMsg
	 * @param psid
	 * @param encryptData
	 * @throws Exception
	 */
	public static void showNotification(final Context context, final JSONObject jsonMsg, final String psid, final String encryptData) throws Exception {
	    String extData = "";
	    final String SEQNO = jsonMsg.getString("SEQNO");
	    if (jsonMsg.has(PushConstants.KEY_EXT)) {
	        extData = jsonMsg.getString(PushConstants.KEY_EXT);
	    }

	    // EXT가 존재할 경우 다음과 같은 형태로 전달됨
	    // extData = "http:/211.241.199.158:8180/msg/totalInfo/0218115649_msp.html";
	    if (extData.startsWith("http")) { // HTTP 로 시작하는 url 형태일 경우 - 메세지 구분을 위한 스트링 형태로 서버로부터 내려받는다.
	    	// HttpGetStringThread로부터 응답값을 받은 후 처리 로직
			final String finalExtData = extData;
			Handler handler = new Handler() {
				@Override
				public void handleMessage(Message msg) {
	        		if(msg.what == 0) {
	        			String message = (String) msg.obj;
	        			if (message != null) {
	        				//message = message.replaceAll("https", "http");
	        				message = message.replaceAll("\\\\", "/");

	        				try { 
	        					// 다음과 같은 형태로 응답 값이 구성되었을 경우 치환을 위한 로직 수행
	        					// "TYPE":"R","VAR":"hoseok|2015-06-31|2015-07-30|104320|11"
	        					if (jsonMsg.has("TYPE") && jsonMsg.getString("TYPE").equals("R")) {
	        						String var = jsonMsg.getString("VAR");
	        						HashMap<String, String> varMap = new HashMap<String, String>();
	        						if (var != null) {
	        							String[] varArray = var.split("\\|");
	        							for (int i=0; i<varArray.length; i++) {
	        								int idx = i+1;
	        								varMap.put("%VAR" + idx + "%", varArray[i]);
	        								//Log.d("test", "%VAR" + idx + "%" + " " +  varArray[i]);
	        							}
	        							
	        							Iterator<?> keys = varMap.keySet().iterator();
	        							while (keys.hasNext()) {
	        								String key = (String) keys.next();
	        								message = message.replaceAll(key, varMap.get(key));
	        								//Log.d("test", "message: " + message);
	        							}
	        						}
	        					}
	        				} catch (JSONException e) {
	        					e.printStackTrace();
	        				}
	        			}
						if (Objects.equals(message, "")) {
							createNotification(context, jsonMsg, psid, encryptData, finalExtData);
						}else {
							Log.e("message::",message);
							createNotification(context, jsonMsg, psid, encryptData, message);
						}
	        		}
				}
			};
			// EXT url 로부터 메세지 정보를 수신하기 위한 쓰레드
			new GetStringHttpThread(handler, extData).start();
		}
		else { // 일반 스크링의 경우
			createNotification(context, jsonMsg, psid, encryptData, extData);
		}
	}	
	
	/**
	 * createNotification
	 * 노티피케이션 생성
	 * @param context
	 * @param jsonMsg
	 * @param psid
	 * @param encryptData
	 * @param message
	 */
	private static void createNotification(final Context context, final JSONObject jsonMsg, final String psid, final String encryptData, String message) {
		ArrayList<String> params = null;
		if (message != null) {
			String[] paramArray = message.split("\\|");
			params = new ArrayList<String>(Arrays.asList(paramArray));
		}
		try {
			jsonMsg.remove("EXT");
			jsonMsg.put("EXT", message);
		} catch (JSONException e) {
			e.printStackTrace();
		}
		Log.e("KEY_SEQNO::",jsonMsg.optString(PushConstants.KEY_SEQNO));
		Log.e("sender::", jsonMsg.optString("SENDERCODE"));
		String seqNo, sender;
		seqNo = jsonMsg.optString(PushConstants.KEY_SEQNO);
		sender = jsonMsg.optString("SENDERCODE");

		if (message != null && !message.contains("|")){
			String imgUrl = "";
			DBUtils.getDbOpenHelper(context).insertPushMSG(seqNo, ContentType.TYPE_DEFAULT, message, psid, message, 1, jsonMsg.toString(),sender);
			try {
				JSONObject object = new JSONObject(message);
				Log.e("message::",object.getString("imageUrl"));
				imgUrl = object.getString("imageUrl");
				if(imgUrl.isEmpty()){
					defaultNotification(context, jsonMsg, message, psid, message, encryptData, null);
				}else{
					showImageNotification(context, jsonMsg, message, imgUrl, psid, message);
				}
			} catch (JSONException e) {
				defaultNotification(context, jsonMsg, message, psid, message, encryptData, null);
			}
		}

		// 메세지 타입에 따라 노티피케이션 생성 - 용도에 따라 커스터마이징하여 사용이 가능 (타입 번호/파싱 룰 등등..)
		if (params != null && params.size() > 0) {
			Log.d("NotificationManager", "[NotificationManager] params size:: " + params.size());
			try {
				// URL을 실제 상세 메세지 데이터로 치환
				jsonMsg.remove(PushConstants.KEY_EXT);
				jsonMsg.put(PushConstants.KEY_EXT, message);
				
				// 일반 메세지의 경우
				if (params.get(0).equals("0") || params.get(0).equals("4") || params.get(0).equals("6")) {
					Log.d("NotificationManager", "[NotificationManager] defaultNotification: " + message);
					DBUtils.getDbOpenHelper(context).insertPushMSG(seqNo, ContentType.TYPE_DEFAULT, "title", "body", params.get(1), 1, jsonMsg.toString(),sender);
					defaultNotification(context, jsonMsg, params.get(1), psid, message, encryptData,null);
				} else if (params.get(0).equals("11")) { //시큐어 푸시를 위한 구분 (Icon 이미지를 포함한 ext)
					Log.d("NotificationManager", "[NotificationManager] defaultNotification(11): " + message);
					DBUtils.getDbOpenHelper(context).insertPushMSG(seqNo, ContentType.TYPE_IMAGE, "title", "body", params.get(1), 1, jsonMsg.toString(),sender);
					showIconNotification(context, jsonMsg, params.get(1), psid, message, encryptData, params.get(2));
				}
				// 이미지 메세지의 경우
				else if (params.size() > 2) {
					Log.d("NotificationManager", "[NotificationManager] showImageNotification: " + message);
					String url = params.get(2);
					if (TextUtils.isEmpty(url) || "null".equals(url)) {
						DBUtils.getDbOpenHelper(context).insertPushMSG(seqNo, ContentType.TYPE_IMAGE, "title", "body", params.get(1), 1, jsonMsg.toString(),sender);
						defaultNotification(context, jsonMsg, params.get(1), psid, message, encryptData, null);
					} else {
						DBUtils.getDbOpenHelper(context).insertPushMSG(seqNo, ContentType.TYPE_IMAGE, "title", "body", params.get(2), 1, jsonMsg.toString(),sender);
						showImageNotification(context, jsonMsg, params.get(1), params.get(2), psid, message);
					}
				}
				// 기타의 경우 - 일반메세지로 처리했으나 용도에 맞게 변경
				else {
					Log.d("NotificationManager", "[NotificationManager] UNKNOUWN TYPE:: " + params.get(0));
					defaultNotification(context, jsonMsg, message, psid, message, encryptData, null);
				}
			} 
			catch (Exception e) {
				e.printStackTrace();
			}
		}
	}

	private static void showIconNotification(final Context context, final JSONObject jsonMsg,
											 final String strMessage, final String psid, final String ext, final String encryptData, String iconPath) {

		//iconPath = "http://211.241.199.216:28080/secure-push-gw/ic_default.png";
		if (!iconPath.startsWith("http://")) {
			iconPath = iconPath.replaceAll("http:/", "http://");
		}
		if (!ImageLoader.getInstance().isInited()) {
			ImageLoaderConfiguration config = new ImageLoaderConfiguration.Builder(context).build();
			ImageLoader.getInstance().init(config);
		}
		ImageLoader.getInstance().loadImage(iconPath, new SimpleImageLoadingListener() {
			@Override
			public void onLoadingFailed(String imageUri, View view, FailReason failReason) {
				defaultNotification(context, jsonMsg, strMessage, psid, ext, encryptData, null);
			}

			@Override
			public void onLoadingComplete(String imageUri, View view, Bitmap loadedImage) {
				System.out.println("loadedImage.getWidth(): " + loadedImage.getWidth());
				System.out.println("loadedImage.getHeight(): " + loadedImage.getHeight());
				Bitmap scaledImage = Bitmap.createScaledBitmap(loadedImage, 192, 192, false);
				if (loadedImage != null) {
					loadedImage.recycle();
					loadedImage = null;
				}
				defaultNotification(context, jsonMsg, strMessage, psid, ext, encryptData, scaledImage);
			}
		});
	}
	public static String NOTIFICATION_CHANNEL_ID = "";
	public static CharSequence name = "";
	private static void defaultNotification(Context context, JSONObject jsonMsg, String strMessage, String psid, String ext, String encryptData, Bitmap loadedIcon) {
		NOTIFICATION_CHANNEL_ID = context.getPackageName() + "_1";
		String alertMessage = "";
		String title = getAppName(context);
		int seqno = 0;
		try {
			alertMessage = jsonMsg.getString(PushConstants.KEY_MESSAGE);
			title = getAppName(context);
			seqno = Integer.parseInt(jsonMsg.getString(PushConstants.KEY_SEQNO));
		} catch (Exception e1) {
			e1.printStackTrace();
		}

		ApplicationInfo app = null;
		try {
			app = context.getPackageManager().getApplicationInfo(context.getPackageName(), 0);
			icon = app.icon;
		} catch (PackageManager.NameNotFoundException e) {
			icon = context.getResources().getIdentifier("ic_launcher", "mipmap", context.getPackageName());
		}

		Intent intent = null;
		if (Utils.IsRunningApp(context)) {
			// 앱이 실행중이면
			if (Utils.getConfigString(context, CommonDef.CONFIG_SAVE_LOGIN).equalsIgnoreCase("Y")) {
				intent = new Intent(context, PushListActivity.class);
			} else {
				intent = new Intent(context, LoginActivity.class);
			}
			intent.addFlags(Intent.FLAG_ACTIVITY_NEW_TASK
					| Intent.FLAG_ACTIVITY_CLEAR_TOP
					| Intent.FLAG_ACTIVITY_SINGLE_TOP);
		} else {
			intent = new Intent(Intent.ACTION_MAIN);
			intent.addCategory(Intent.CATEGORY_LAUNCHER);
			intent.setComponent(new ComponentName(context, IntroActivity.class));
		}


		NotificationManager mManager = (NotificationManager)context.getSystemService(Context.NOTIFICATION_SERVICE);
		name = getAppName(context);
		PendingIntent pIntent = PendingIntent.getActivity(context, seqno, intent, PendingIntent.FLAG_UPDATE_CURRENT | PendingIntent.FLAG_IMMUTABLE);
		Uri soundUri = RingtoneManager.getDefaultUri(RingtoneManager.TYPE_NOTIFICATION);

		if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.O) {
			int importance = NotificationManager.IMPORTANCE_HIGH;
			NotificationChannel mChannel = new NotificationChannel(NOTIFICATION_CHANNEL_ID, name, importance);
			mChannel.setDescription(context.getPackageName());
			mChannel.enableLights(true);
			mChannel.setLightColor(Color.RED);
			mChannel.enableVibration(true);
			//mChannel.setVibrationPattern(new long[]{100, 200, 300, 400, 500, 400, 300, 200, 400});
			mManager.createNotificationChannel(mChannel);
		}

		if (notification != null) {
			if (notification.mChannel != null){
				if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.O) {
					mManager.createNotificationChannel(notification.mChannel);
				}
				mManager.notify("upns",seqno, PushManager.customBuilder(context, notification, pIntent,icon));
			}else{
				mManager.notify("upns",seqno, PushManager.customBuilder(context, notification, pIntent,icon));
			}
		}else {
			NotificationCompat.Builder mBuilder = new NotificationCompat.Builder(context.getApplicationContext(), NOTIFICATION_CHANNEL_ID)
					.setAutoCancel(true)
					.setContentIntent(pIntent)
					// .setLargeIcon(BitmapFactory.decodeResource(context.getResources(), icon))
					.setContentTitle(title)
					.setContentText(alertMessage)
					.setStyle(new NotificationCompat.BigTextStyle().bigText(alertMessage).setBigContentTitle(title))
					.setTicker(title)
					.setSound(soundUri)
					.setPriority(Notification.PRIORITY_HIGH);
			if (icon != 0){
				mBuilder.setSmallIcon(icon);
			}
			final Notification notify = mBuilder.build();
			mManager.notify("upns", seqno, notify);
		}
	}
	
	private static void showImageNotification(Context context, final JSONObject jsonMsg, final String strMessage, String img, final String psid, final String ext) {
		ApplicationInfo app = null;
		try {
//            PackageManager packageManager = context.getPackageManager();
//            Drawable appIcon = packageManager.getApplicationIcon(context.getPackageName());
			app = context.getPackageManager().getApplicationInfo(context.getPackageName(), 0);
			icon = app.icon;
		} catch (PackageManager.NameNotFoundException e) {
			icon = context.getResources().getIdentifier("ic_launcher", "mipmap", context.getPackageName());
		}
		final String title = getAppName(context);
		final Context ctx = context;
		
		if (img.contains("https")) {
			//img = img.replaceAll("https", "http");
			img = img.replaceAll("\\\\", "/");
		}

		ImageLoaderConfiguration config = new ImageLoaderConfiguration.Builder(context).build();
		ImageLoader.getInstance().init(config);
		ImageLoader.getInstance().loadImage(img, new SimpleImageLoadingListener() {

			@Override
			public void onLoadingComplete(String imageUri, View view, Bitmap loadedImage) {
				notificationWithBigPicture(ctx, jsonMsg, title, strMessage, icon, loadedImage, psid, ext);
			}
		});
	}
	
	private static void notificationWithBigPicture(Context context, JSONObject jsonMsg, String title, String message, int icon, Bitmap banner, String psid, String ext) {

		Intent intent = setIntent(context);
		intent.putExtra(PushConstants.KEY_JSON, jsonMsg.toString());
		intent.putExtra(PushConstants.KEY_PSID, psid);
		intent.putExtra(PushConstants.KEY_TITLE, message);
		intent.putExtra(PushConstants.KEY_EXT, ext);
//		intent.addFlags(Intent.FLAG_ACTIVITY_NO_HISTORY);
    	int seqno = 0;

		NOTIFICATION_CHANNEL_ID = context.getPackageName() +"_1";
		name = getAppName(context);

		try {
			seqno = Integer.parseInt(jsonMsg.getString("SEQNO"));
		} catch (NumberFormatException e) {
			e.printStackTrace();
		} catch (JSONException e) {
			e.printStackTrace();
		}

		NotificationManager mManager = (NotificationManager)context.getSystemService(Context.NOTIFICATION_SERVICE);
		if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.O) {
			int importance = NotificationManager.IMPORTANCE_HIGH;
			String Description = context.getPackageName();
			NotificationChannel notificationChannel = new NotificationChannel(NOTIFICATION_CHANNEL_ID, name, importance);
			notificationChannel.setDescription(Description);
			notificationChannel.enableLights(true);
			notificationChannel.setLightColor(Color.RED);
			notificationChannel.enableVibration(true);
			//mChannel.setVibrationPattern(new long[]{100, 200, 300, 400, 500, 400, 300, 200, 400});
			assert mManager != null;
			mManager.createNotificationChannel(notificationChannel);
		}

		//PendingIntent pendingIntent = PendingIntent.getActivity(context, seqno, intent, PendingIntent.FLAG_UPDATE_CURRENT | PendingIntent.FLAG_IMMUTABLE);
		PendingIntent pendingIntent = PendingIntent.getActivity(context, 0, intent, PendingIntent.FLAG_CANCEL_CURRENT | PendingIntent.FLAG_IMMUTABLE);

		if (notification != null) {
			if (notification.mChannel!=null){
				if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.O) {
					mManager.createNotificationChannel(notification.mChannel);
				}
				mManager.notify("upns",seqno,PushManager.customBuilder(context, notification, pendingIntent,icon));
			}else{
				mManager.notify("upns",seqno, PushManager.customBuilder(context,notification, pendingIntent,icon));
			}
		}else {
			NotificationCompat.Builder builder = new NotificationCompat.Builder(context, NOTIFICATION_CHANNEL_ID)
					.setTicker(title)
					.setContentTitle(title)
					.setContentText(message)
					.setAutoCancel(true)
					.setPriority(Notification.PRIORITY_HIGH)
					.setChannelId(NOTIFICATION_CHANNEL_ID);

			NotificationCompat.BigPictureStyle style = new NotificationCompat.BigPictureStyle();
			style.setBigContentTitle(title);
			style.setSummaryText(message);
			style.bigPicture(banner);
			builder.setStyle(style);
			builder.setContentIntent(pendingIntent);
			builder.setDefaults(Notification.DEFAULT_VIBRATE);
			builder.setSound(RingtoneManager.getDefaultUri(RingtoneManager.TYPE_NOTIFICATION));
			if (icon !=0){
				builder.setSmallIcon(icon);
			}
			mManager.notify("upns", seqno, builder.build());
		}
	}
	public static String getAppName(Context context) {
		String appName = "";
		try {
			PackageManager pm = context.getPackageManager();
			PackageInfo i = pm.getPackageInfo(context.getPackageName(), 0);
			appName = i.applicationInfo.loadLabel(pm) + "";
		} catch(PackageManager.NameNotFoundException e) { }
		return appName;
	}

	public static Intent setIntent(Context context){
		boolean isRunningApp = PushUtils.isRunningPushApps(context);
		PackageManager packageManager = context.getPackageManager();
		Class klass = null;
		Intent intent;
		try {
			klass = Class.forName("m.client.library.plugin.push.PushMessageManager");
			intent = new Intent(context, klass);
		} catch (Exception e){
			intent = packageManager.getLaunchIntentForPackage(context.getPackageName());
			Log.d("exeption::",e.toString());
		}
		intent.putExtra("PUSH_TYPE", "UPNS");
		intent.putExtra("PUSH_STATUS", (isRunningApp) ? PushConstants.APP_STATUS_ACTIVE : PushConstants.APP_STATUS_BACKGROUND);
		intent.addFlags(Intent.FLAG_ACTIVITY_NEW_TASK | Intent.FLAG_ACTIVITY_CLEAR_TOP | Intent.FLAG_ACTIVITY_SINGLE_TOP);
		//intent.addFlags(Intent.FLAG_ACTIVITY_NO_HISTORY);
		return intent;
	}

}