package com.uracle.cloudpush.receiver;

import m.client.push.library.PushManager;
import m.client.push.library.common.Logger;
import m.client.push.library.common.PushConstants;
import m.client.push.library.notification.UpnsNotifyHelper_Basic;

import com.uracle.cloudpush.helper.PushNotifyHelper;
import com.uracle.cloudpush.notification.PushNotificationManager;
import com.uracle.cloudpush.notification.UpnsNotifyHelper;
import com.uracle.cloudpush.notification.UpnsNotifyHelper2;

import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.os.Handler;
import android.util.Log;
import android.widget.Toast;

import org.json.JSONObject;

public class MessageArrivedReceiver extends BroadcastReceiver {

	@Override
	public void onReceive(final Context context, Intent intent) {
		Log.e("MessageArrivedReceiver","MessageArrivedReceiver");
		if (intent.getAction().equals(context.getPackageName() + PushConstants.ACTION_GCM_MESSAGE_ARRIVED)) {
			try {

				// 수신된 payload data 는 아래 3가지 방식으로 획득 할 수 있다.
				String data = intent.getExtras().getString(PushConstants.KEY_JSON);
				final String rawData = intent.getExtras().getString(PushConstants.KEY_ORIGINAL_PAYLOAD_STRING);
				byte[] rawDataBytes = intent.getExtras().getByteArray(PushConstants.KEY_ORIGINAL_PAYLOAD_BYTES);
				final String encryptData = intent.getExtras().getString(PushConstants.KEY_MESSAGE_ENCRYPT);
				String psid = intent.getExtras().getString("PSID");
				Logger.i(new JSONObject(data).toString(2));
				Logger.i("received raw data : " + rawData);
				Logger.i("received bytes data : " + new String(rawDataBytes, "utf-8"));

				JSONObject rootJsonObj = new JSONObject(data);

				Log.e("MessageArrivedReceiver","MessageArrivedReceiver");
				UpnsNotifyHelper.showNotification(context, rootJsonObj, psid, encryptData);

				//푸시 메시지 수신 ack
				PushManager.getInstance().pushMessageReceiveConfirm(context, data);
			} catch (Exception e) {
				e.printStackTrace();
			}
		}else{
			try {
				String data = intent.getExtras().getString(PushConstants.KEY_JSON);
				JSONObject jsonMsg = new JSONObject(data);
				String psid = intent.getExtras().getString(PushConstants.KEY_PSID);
				final String encryptData = intent.getExtras().getString(PushConstants.KEY_MESSAGE_ENCRYPT);
				UpnsNotifyHelper2.showNotification(context, jsonMsg, psid, encryptData);
				PushManager.getInstance().pushMessageReceiveConfirm(context, data);
			}
			catch(Exception e) {
				e.printStackTrace();
			}
		}
	}
}
